package application;
import java.util.ArrayList;

public class Arbre {

	private Coup coup;
	private byte val;
	private boolean victoire;
	private ArrayList<Arbre> fils;
	
	public Arbre() {
		this.coup = null;
		this.val = 0;
		this.fils = new ArrayList<>();
		this.victoire = false;
		
	}
	
	public Arbre(Coup coup) {
		this.coup = coup;
		this.val = 0;
		this.fils = new ArrayList<Arbre>();
		this.victoire = false;
	}
	
	public Arbre(Coup coup, int val, ArrayList<Arbre> fils, Arbre pere, boolean victoire) {
		this.coup = coup;
		this.val = (byte) val;
		this.fils = fils;
		this.victoire = victoire;
	}
	
	public Coup getCoup() {
		return coup;
	}

	public int getVal() {
		return val;
	}
	
	public boolean coupGagnant() {
		return victoire;
	}

	public ArrayList<Arbre> getFils() {
		return fils;
	}
	
	public static Arbre getFils (Arbre arbre, Coup c) {
		
		for (Arbre a : arbre.fils) {
			if (c.equals(a.coup)) {
				return a;				
			}
		}
		
		return null;
	}
	
	public void ajouterFils (Arbre f) {
		fils.add(f);
	}
	
	public void setVal(int val) {
		this.val = (byte) val;
	}
	
	public void estGagnant() {
		victoire = true;
		val = 100;
	}
	
}
